blob: 98ebd67ad9f71b1490fb3c4e1720a89f112294f0 [file] [log] [blame]
Igor Murashkineaddcd42012-11-26 12:01:11 -08001#!/bin/bash
2
3#
4# Copyright (C) 2012 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
18
19#
20# Generate all files we have templates for:
21# docs.html
22# ../src/camera_metadata_tag_info.c
23# ../src/camera_metadata_tags.h
Colin Crossabc7c492017-05-05 09:36:03 -070024# ../../../../frameworks/av/camera/ndk/include/camera/NdkCameraMetadataTags.h
Yin-Chia Yehea7662f2015-12-22 16:25:00 -080025# ../../../../frameworks/av/camera/ndk/impl/ACameraMetadata.cpp
Yin-Chia Yeh6c58d0a2015-12-05 17:20:33 -080026# ../../../../cts/tests/camera/src/android/hardware/camera2/cts/CaptureResultTest.java
Igor Murashkin21d0f1a2013-09-10 12:25:56 -070027# ../../../../frameworks/base/core/java/android/hardware/camera2/CameraCharacteristics.java
28# ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureRequest.java
29# ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureResult.java
Igor Murashkineaddcd42012-11-26 12:01:11 -080030
Igor Murashkinaa133d32013-06-28 17:27:49 -070031if [[ -z $ANDROID_BUILD_TOP ]]; then
32 echo "Please source build/envsetup.sh before running script" >& 2
33 exit 1
34fi
35
Eino-Ville Talvala08885562013-03-18 09:43:57 -070036thisdir=$(cd "$(dirname "$0")"; pwd)
Eino-Ville Talvala47aa24d2013-07-25 17:10:11 -070037fwkdir="$ANDROID_BUILD_TOP/frameworks/base/core/java/android/hardware/camera2/"
Eino-Ville Talvala0d404952017-11-10 15:13:04 -080038fwkdir_html="$ANDROID_BUILD_TOP/frameworks/base/docs/html/reference"
Yin-Chia Yeh00d504d2018-03-15 11:08:49 -070039ndkdir_html="$ANDROID_BUILD_TOP/frameworks/native/docs"
Eino-Ville Talvaladafa6532017-11-17 14:48:20 -080040hidldir="$ANDROID_BUILD_TOP/hardware/interfaces/camera/metadata"
Yin-Chia Yeh6c58d0a2015-12-05 17:20:33 -080041ctsdir="$ANDROID_BUILD_TOP/cts/tests/camera/src/android/hardware/camera2/cts"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070042outdir="$ANDROID_PRODUCT_OUT/obj/ETC/system-media-camera-docs_intermediates"
Colin Crossabc7c492017-05-05 09:36:03 -070043ndk_header_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/include/camera"
Yin-Chia Yehea7662f2015-12-22 16:25:00 -080044ndk_impl_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/impl"
Yin-Chia Yehcf145ce2016-04-01 17:37:47 -070045device_info_dir="$ANDROID_BUILD_TOP/cts/tools/cts-device-info/"`
46 `"src/com/android/cts/deviceinfo"
Igor Murashkin1232dd22013-06-21 12:10:42 -070047out_files=()
Igor Murashkineaddcd42012-11-26 12:01:11 -080048
Igor Murashkin5804a482012-12-05 13:06:59 -080049function relpath() {
50 python -c "import os.path; print os.path.relpath('$1', '$PWD')"
51}
52
Igor Murashkin1232dd22013-06-21 12:10:42 -070053# Generates a file. Appends to $out_files array as a side effect.
Igor Murashkineaddcd42012-11-26 12:01:11 -080054function gen_file() {
55 local in=$thisdir/$1
56 local out=$thisdir/$2
57
Igor Murashkinaa133d32013-06-28 17:27:49 -070058 gen_file_abs "$in" "$out"
59 return $?
60}
61
62function gen_file_abs() {
63 local in="$1"
64 local out="$2"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070065 local intermediates="$3"
Eino-Ville Talvaladafa6532017-11-17 14:48:20 -080066 local hal_version="${4:-3.2}"
Eino-Ville Talvala0d404952017-11-10 15:13:04 -080067 local spec_file=$thisdir/metadata_definitions.xml
Yin-Chia Yehc9c2c682016-05-25 01:29:55 -070068
Eino-Ville Talvaladafa6532017-11-17 14:48:20 -080069 python $thisdir/metadata_parser_xml.py $spec_file $in $out $hal_version
Igor Murashkin5804a482012-12-05 13:06:59 -080070
71 local succ=$?
72
73 if [[ $succ -eq 0 ]]
74 then
75 echo "OK: Generated $(relpath "$out")"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070076 if [[ "$intermediates" != "no" ]]; then
77 out_files+=$'\n'" $out"
78 fi
Igor Murashkin5804a482012-12-05 13:06:59 -080079 else
80 echo "FAIL: Errors while generating $(relpath "$out")" >& 2
81 fi
82
83 return $succ
Igor Murashkineaddcd42012-11-26 12:01:11 -080084}
85
Igor Murashkin1232dd22013-06-21 12:10:42 -070086# Print a list of git repository paths which were affected after file generation
87function affected_git_directories() {
88 local input_files=($@)
89 local git_directories=()
90
91 for file in "${input_files[@]}"; do
92 local dir_path="$(dirname "$file")"
93 echo "Trying to cd into $dir_path" >& /dev/null
94 # Absolute path to the git repository root of that file
95 local git_path="$(cd "$dir_path";
96 git rev-parse --show-toplevel 2> /dev/null)"
97 if [[ $? -eq 0 ]]; then
98 # Both staged and unstaged changes
Igor Murashkinb8dc8812013-07-17 16:29:34 -070099 local diff_result="$(cd "$dir_path";
100 git status --porcelain | egrep -c -v '^[?][?]')"
Igor Murashkin1232dd22013-06-21 12:10:42 -0700101 echo "Diff result was $diff_result" >& /dev/null
102 echo "Diff result was $diff_result" >& /dev/null
103 if [[ $diff_result -eq 0 ]]; then
Igor Murashkinaa133d32013-06-28 17:27:49 -0700104 echo "No changes in ${git_path}" >& /dev/null
Igor Murashkin1232dd22013-06-21 12:10:42 -0700105 else
106 echo "There are changes in ${git_path}" >& /dev/null
107 git_directories+=("$git_path")
108 fi
109 fi
110 done
111
112 # print as result the unique list of git directories affected
Igor Murashkinaa133d32013-06-28 17:27:49 -0700113 printf %s\\n "${git_directories[@]}" | sort | uniq
Igor Murashkin1232dd22013-06-21 12:10:42 -0700114}
115
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700116# Insert a file into the middle of another, starting at the line containing the
117# start delim and ending on the end delim, both of which are replaced
118function insert_file() {
119 local src_part="$1"
120 local dst_file="$2"
121 local start_delim="/*@O~"
122 local end_delim="~O@*/"
123
124 local start_line="$(grep -n -F "${start_delim}" "${dst_file}" | cut -d: -f1)"
125 local end_line="$(grep -n -F "${end_delim}" "${dst_file}" | cut -d: -f1)"
126
127 # Adjust cutoff points to use start/end line from inserted file
128 (( start_line-- ))
129 (( end_line++ ))
130
131 # Do some basic sanity checks
132
133 if [[ -z "$start_line" ]]; then
134 echo "No starting delimiter found in ${dst_file}" >& 2
135 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
136 return 1
137 fi
138
139 if [[ -z "$end_line" ]]; then
140 echo "No ending delimiter found in ${dst_file}" >& 2
141 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
142 return 1
143 fi
144
145 if [[ "$start_line" -ge "$end_line" ]]; then
146 echo "Starting delim later than ending delim: $start_line vs $end_line" >& 2
147 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
148 return 1
149 fi
150
151 local tmp_name=$(mktemp -t XXXXXXXX)
152
153 # Compose the three parts of the final file together
154
155 head -n "$start_line" "${dst_file}" > "${tmp_name}"
156 cat "${src_part}" >> "${tmp_name}"
157 tail -n "+${end_line}" "${dst_file}" >> "${tmp_name}"
158
159 # And replace the destination file with the new version
160
161 mv "${tmp_name}" "${dst_file}"
162 echo "OK: Inserted $(relpath "$src_part") into $(relpath "$dst_file")"
163 out_files+=$'\n'" $dst_file"
164}
165
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800166# Recursively copy a directory tree from $1 to $2. Pretty-prints status.
167function copy_directory() {
168 local src="$thisdir/$1" # Relative to directory of this script
169 local dst="$2" # Absolute path
170
171 if ! [[ -d $src ]]; then
172 echo "FAIL: Source directory $src does not exist" >& 2
173 return 1
174 fi
175 if ! [[ -d $dst ]]; then
176 echo "FAIL: Destination directory $dst does not exist" >& 2
177 return 1
178 fi
179
180 cp -R "$src" "$dst"
181 local retval=$?
182
183 if [[ $retval -ne 0 ]]; then
184 echo "ERROR: Failed to copy $(relpath "$src") to $(relpath "$dst")" >& 2
185 else
186 echo "OK: Copied $(relpath "$src") to $(relpath "$dst")"
Yin-Chia Yeh00d504d2018-03-15 11:08:49 -0700187 out_files+=$'\n'" $dst"
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800188 fi
189
190 return $retval
191}
192
Igor Murashkin0334aa02012-12-04 14:59:53 -0800193$thisdir/metadata-check-dependencies || exit 1
Eino-Ville Talvala0d404952017-11-10 15:13:04 -0800194$thisdir/metadata-validate $thisdir/metadata_definitions.xml || exit 1
Igor Murashkineaddcd42012-11-26 12:01:11 -0800195$thisdir/metadata-parser-sanity-check || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700196
197# Generate HTML properties documentation
Igor Murashkineaddcd42012-11-26 12:01:11 -0800198gen_file html.mako docs.html || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700199
200# Generate C API headers and implementation
Igor Murashkineaddcd42012-11-26 12:01:11 -0800201gen_file camera_metadata_tag_info.mako ../src/camera_metadata_tag_info.c || exit 1
202gen_file camera_metadata_tags.mako ../include/system/camera_metadata_tags.h || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700203
Eino-Ville Talvaladafa6532017-11-17 14:48:20 -0800204# Generate HIDL metadata modules - new versions need to be added here manually
205mkdir -p "${hidldir}/3.2"
206gen_file_abs HidlMetadata.mako "$hidldir/3.2/types.hal" yes 3.2 || exit 1
Eino-Ville Talvala63674ff2017-12-07 13:06:05 -0800207mkdir -p "${hidldir}/3.3"
208gen_file_abs HidlMetadata.mako "$hidldir/3.3/types.hal" yes 3.3 || exit 1
Eino-Ville Talvaladafa6532017-11-17 14:48:20 -0800209
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800210#Generate NDK header
Eino-Ville Talvala0d404952017-11-10 15:13:04 -0800211gen_file_abs ndk_camera_metadata_tags.mako "$ndk_header_dir/NdkCameraMetadataTags.h" yes || exit 1
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800212
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700213# Generate Java API definitions
214mkdir -p "${outdir}"
215gen_file_abs CameraMetadataEnums.mako "$outdir/CameraMetadataEnums.java.part" no || exit 1
Igor Murashkin21d0f1a2013-09-10 12:25:56 -0700216gen_file_abs CameraCharacteristicsKeys.mako "$outdir/CameraCharacteristicsKeys.java.part" no || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700217gen_file_abs CaptureRequestKeys.mako "$outdir/CaptureRequestKeys.java.part" no || exit 1
218gen_file_abs CaptureResultKeys.mako "$outdir/CaptureResultKeys.java.part" no || exit 1
219
220insert_file "$outdir/CameraMetadataEnums.java.part" "$fwkdir/CameraMetadata.java" || exit 1
Igor Murashkin21d0f1a2013-09-10 12:25:56 -0700221insert_file "$outdir/CameraCharacteristicsKeys.java.part" "$fwkdir/CameraCharacteristics.java" || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700222insert_file "$outdir/CaptureRequestKeys.java.part" "$fwkdir/CaptureRequest.java" || exit 1
223insert_file "$outdir/CaptureResultKeys.java.part" "$fwkdir/CaptureResult.java" || exit 1
Yin-Chia Yehc9b27dd2016-02-23 19:18:15 -0800224
225# Generate CTS test code
226gen_file_abs CaptureResultTest.mako "$outdir/CaptureResultTest.java.part" no || exit 1
Yin-Chia Yeh3a52b8f2015-05-05 23:49:07 -0700227insert_file "$outdir/CaptureResultTest.java.part" "$ctsdir/CaptureResultTest.java" || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700228
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800229# Generate NDK implementation
230gen_file_abs ACameraMetadata.mako "$outdir/ACameraMetadata.cpp.part" no || exit 1
231insert_file "$outdir/ACameraMetadata.cpp.part" "$ndk_impl_dir/ACameraMetadata.cpp" || exit 1
232
Yin-Chia Yehc9b27dd2016-02-23 19:18:15 -0800233# Generate CameraDeviceInfo code
234gen_file_abs CameraDeviceInfo.mako "$outdir/CameraDeviceInfo.java.part" no || exit 1
235insert_file "$outdir/CameraDeviceInfo.java.part" "$device_info_dir/CameraDeviceInfo.java" || exit 1
236
237# Generate protocol buffer definition corresponding to CameraDeviceInfo
238gen_file camera_device_info.mako ./camera_device_info.proto || exit 1
239
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800240# Copy ./images directory into javadoc directory
241copy_directory "images" "$fwkdir_html" || exit 1
242
Yin-Chia Yeh00d504d2018-03-15 11:08:49 -0700243# Copy ./images directory into ndk doc directory
244copy_directory "images" "$ndkdir_html" || exit 1
245
Igor Murashkin1232dd22013-06-21 12:10:42 -0700246echo ""
247echo "===================================================="
Igor Murashkineaddcd42012-11-26 12:01:11 -0800248echo "Successfully generated all metadata source files"
Igor Murashkin1232dd22013-06-21 12:10:42 -0700249echo "===================================================="
250echo ""
251
252echo "****************************************************"
253echo "The following git repositories need to be committed:"
254echo "****************************************************"
255echo ""
256affected_git_directories "${out_files[@]}"
257echo ""
Igor Murashkineaddcd42012-11-26 12:01:11 -0800258
259exit 0